package tsyliveaudiorecord.live_audio_record;

import androidx.annotation.NonNull;

public interface AudioVisualization {

    /**
     * Link view to custom implementation of {@link DbmHandler}.
     *
     * @param dbmHandler instance of DbmHandler
     */
    <T> void linkTo(@NonNull DbmHandler<T> dbmHandler);

    /**
     * Resume audio visualization.
     */
    void onResume();

    /**
     * Pause audio visualization.
     */
    void onPause();

    /**
     * Release resources of audio visualization.
     */
    void release();
}
