import 'package:json_annotation/json_annotation.dart';
import 'package:vais_speech/model/base_response.dart';
part "page_response.g.dart";

@JsonSerializable()
class PageResponse extends BaseResponse {
  @JsonKey(name: 'total_item')
  int? totalItems;
  @JsonKey(name: 'total_page')
  int? totalPages;
  @JsonKey(name: 'has_more')
  bool? hasMore;
  @JsonKey(name: 'next_page')
  int? nextPage;

  PageResponse(int? code, String? message,
      {this.totalItems, this.totalPages, this.hasMore, this.nextPage})
      : super(code, message);

  factory PageResponse.fromJson(Map<String, dynamic> json) =>
      _$PageResponseFromJson(json);

  Map<String, dynamic> toJson() => _$PageResponseToJson(this);
}
