import 'package:json_annotation/json_annotation.dart';
part 'signature.g.dart';

@JsonSerializable()
class Signature {
  @JsonKey(name: "Content-Type")
  String? contentType;
  String? acl;
  @JsonKey(name: "success_action_status")
  int? successActionStatus;
  String? policy;
  @JsonKey(name: "X-amz-credential")
  String? sign1;
  @JsonKey(name: "X-amz-algorithm")
  String? sign2;
  @JsonKey(name: "X-amz-date")
  String? sign3;
  @JsonKey(name: "X-amz-signature")
  String? sign4;
  String? key;
  String? bucket;


  Signature(this.contentType, this.acl, this.successActionStatus, this.policy,
      this.sign1, this.sign2, this.sign3, this.sign4, this.key, this.bucket);

  factory Signature.fromJson(Map<String, dynamic> json) =>
      _$SignatureFromJson(json);

  Map<String, String?> toJson() => _$SignatureToJson(this);

  @override
  String toString() {
    return 'Signature{contentType: $contentType, acl: $acl, successActionStatus: $successActionStatus, policy: $policy, sign1: $sign1, sign2: $sign2, sign3: $sign3, sign4: $sign4, key: $key, bucket: $bucket}';
  }
}
