import 'model/lyric/lyric_response.dart';
import 'model/status.dart';
import 'repository/network.dart';
import 'vais_speech_audio.dart';
import 'vais_helper.dart';

class VaisSpeech {
  final String? token;

  /// Default is null. You should initialize it before using.
  VaisSpeechAudio? vaisAudio;
  late VaisSpeechHelper _vaisHelper;
  final request ;

  VaisSpeech({this.token,grpcAddress = 'asr-benchmark.vais.vn',port = 50050,this.request = true}) {
    print(grpcAddress);
    print(port);
    vaisAudio = VaisSpeechAudio(token,grpcAddress,port);
    _vaisHelper = VaisSpeechHelper(NetworkRepository(apiKey: token));
  }

  Future<String?> startAsr(String path, {String finalName = ''}) => _vaisHelper.startAsr(path, finalName);

  Future<AudioStatus> getProgress(String audioId) => _vaisHelper.getProgress(audioId);

  Future<TranscriptResponse> getTranscript(String audioId) => _vaisHelper.getTranscript(audioId);
}